"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = void 0;
// When there is no native storage interface, we default to an in-memory map
const memMap = {};
const StorageController = {
  async: 0,
  getItem(path) {
    if (Object.hasOwn(memMap, path)) {
      return memMap[path];
    }
    return null;
  },
  setItem(path, value) {
    memMap[path] = String(value);
  },
  removeItem(path) {
    delete memMap[path];
  },
  getAllKeys() {
    return Object.keys(memMap);
  },
  clear() {
    for (const key in memMap) {
      if (Object.hasOwn(memMap, key)) {
        delete memMap[key];
      }
    }
  }
};
var _default = exports.default = StorageController;